* QL WORLD DIY TOOLKIT - Useful SuperBASIC functions
* Version 1.3, Copyright 1989 & 1990, Simon N Goodwin.
*
start      lea.l    define,a1   Point A1 at definition
           move.w   $110,a2     BP.INIT vector
           jmp      (a2)        Link code to SuperBASIC
*
* LOOKUP starts by fetching a single string parameter 
*
lookup     move.w   $116,a0     Fetch CA.GTSTR vector
           jsr      (a0)        Fetch string parameter
           bne.s    exit        Exit unless it worked
           subq.w   #1,d3       Check for ONE parameter
           bne.s    bad_param   Moan if D3 was not 1
           move.w   0(a1,a6.l),d0
           beq.s    bad_param   Reject a null parameter
           move.w   d0,d5       Save length for later
           lea.l    2(a1),a5    Save offset of text
*
* Equate UPPER/lower case; set bit 5 of parameter bytes
*
           moveq    #32,d7      Case conversion mask
           moveq    #1,d2       Odd/even length mask
           and.l    d0,d2       D2=1 if length is odd
lock_case  or.b     d7,2(a1,a6.l)
           addq.l   #1,a1       Advance through text
           subq.w   #1,d0       Count down length
           bne.s    lock_case   Convert all characters 
           adda.l   d2,a1       Skip odd filler byte?
*
* Now 0(A1,A6.L) -> integer result slot, look up name
* 
           move.l   a1,a4       Protect A1 from MT.JINF
           moveq    #0,d2       Search entire task tree
           moveq    #0,d1       Look for SuperBASIC
           moveq    #2,d0       MT.JINF Trap key
           trap     #1          A0 := base of task 0,0
           move.l   a4,a1       Restore A1 for later
           move.l   a0,a2       A2 -> BASIC system vars
           move.l   24(a2),a0   A0 -> Name Table Start
           move.l   28(a2),d0   D0 -> Name Table End
           move.l   32(a2),d3   D3 -> Name List Start
next_name  move.w   2(a0,a2.l),a3  A3.L is offset in NL
           adda.l   d3,a3       (A3,A2.L) -> Name
           cmp.b    0(a3,a2.l),d5  Compare length
           beq.s    got_length  Length matches!
advance_nl addq.l   #8,a0       Advance through NL
           cmp.l    a0,d0       Stop at the end
           bhi.s    next_name
           moveq    #-7,d4      Signal NOT FOUND
           bra.s    ret_d4
*
bad_param  moveq    #-15,d0     ERR.BP report code
exit       rts                  Return error code in D0
*
* Check the name to see if it matches the parameter
*
got_length move.b   1(a3,a2.l),d4
           or.b     d7,d4       Ensure consistent case
           cmp.b    0(a5,a6.l),d4
           bne.s    advance_nl  Mismatch, try another
           move.w   d5,d6       Save residual length
           subq.w   #2,d6       DBRA count the rest
           bmi.s    found_it    Found name, length 1
           move.l   a5,a4       D4 & A4 are temporaries
check_name move.b   2(a3,a2.l),d4
           or.b     d7,d4       Convert case of name
           addq.l   #1,a3       Step through Name List
           addq.l   #1,a4       Step through parameter
           cmp.b    0(a4,a6.l),d4
           dbne     d6,check_name
           bne.s    advance_nl  Name mismatch, go on
found_it   suba.l   24(a2),a0   A0 := A0 - (BV.NLBAS)
           move.l   a0,d4
           lsr.l    #3,d4       D4 := Name Offset DIV 8
           bra.s    ret_d4
*
* NEWCHAN% scans the SuperBASIC channel table
*
newchan    moveq    #0,d4       Default NEWCHAN% = 0
           move.l   48(a6),a2   A2 := Chan table offset
           move.l   52(a6),a3   A3 := Chan end offset
*
try_chnum  cmpa.l   a3,a2       End of table?
           bcc.s    got_chnum   If so, D4 is NEWCHAN%
           tst.b    0(a2,a6.l)  Un-used entry?
           bmi.s    got_chnum   If so, D4 is NEWCHAN%
           addq.w   #1,d4       Count one more in use
           lea.l    40(a2),a2   Advance to next channel
           bra.s    try_chnum   Keep trying
*
got_chnum  moveq    #2,d1       Allow 2 bytes for result
           move.w   $11A,a2     Fetch BV.CHRIX vector
           jsr      (a2)        Reserve space
           move.l   $58(a6),a1  Get BV.RIP
           subq.l   #2,a1       Make room for an integer
ret_d4     move.w   d4,0(a1,a6.l)
           move.l   a1,$58(a6)  Save new BV.RIP
ret_int    moveq    #3,d4       Indicate integer result
           moveq    #0,d0       Indicate no error
           rts
*
* Most remaining code is shared by UPPER$ and LOWER$
*
lower      moveq    #0,d7       Set lower flag
getstr     move.w   $116,a0     Fetch CA.GTSTR vector
           jsr      (a0)        Fetch string parameter
           bne.s    exit        Exit if error found
           subq.w   #1,d3       Check for ONE parameter
           bne.s    bad_param   Complain unless D3 was 1
           move.w   0(a1,a6.l),d0  D0 := Text length
           beq.s    ret_string  Zero length is trivial
           subq.w   #1,d0       Adjust length for DBRA
           move.l   a1,a2       A2 is moving text ptr
           tst.b    d7          Check entry flag - is
           beq.s    lower_set   this UPPER$ or LOWER$?
*
* Adjust GROUP 2 values for Greek & Russian ROMs, etc.
*
upper_set  moveq    #97,d2      Start of lower Group 1 
           moveq    #122,d3     End of lower Group 1
           move.w   #128,d4     Start of lower Group 2
           move.w   #139,d5     End of lower Group 2 
           bra.s    scanner
lower_set  moveq    #65,d2      Start of CAPS Group 1
           moveq    #90,d3      End of CAPS Group 1
           move.w   #160,d4     Start of CAPS Group 2
           move.w   #171,d5     End of CAPS Group 2
*
* D2 is Start of target group 1, D3 is End of Group 1.
* In group 2, D4 is Start, D5 is End. D2 < D3 < D4 < D5
*
scanner    moveq    #32,d7      Prepare conversion mask
convert    move.b   2(a2,a6.l),d6
           cmp.b    d2,d6
           bcs.s    advance     Ignore all codes < D2
           cmp.b    d3,d6
           bls.s    tweak_case  Tweak Group 1 code
try_group2 cmp.b    d4,d6       Try Group 2
           bcs.s    advance     Ignore if code < D4
           cmp.b    d5,d6
           bhi.s    advance     Too high, no tweak needed
tweak_case eor.b    d7,2(a2,a6.l)
advance    addq.l   #1,a2       Advance through parameter
           dbra     d0,convert
ret_string moveq    #1,d4       String stacked at (A6,A1)
           moveq    #0,d0
           rts
*
upper      moveq    #1,d7       Set UPPER CASE flag
           bra.s    getstr
*
define     dc.w     0,0         No procedures
           dc.w     4           Four functions
           dc.w     newchan-*
           dc.b     8,'NEWCHAN%'
           dc.w     lookup-*
           dc.b     7,'LOOKUP%'
           dc.w     upper-*
           dc.b     6,'UPPER$'
           dc.w     lower-*
           dc.b     6,'LOWER$'
           dc.w     0
           end
