* MINERVA REPLACE
*
* This version of REPLACE is modified by Laurence Reeves to
* take account of Minerva integer tokens. It should be used
* instead of the DIY version if you have a late release of
* Minerva (1.77 or later) and have not turned off integer
* tokens with POKE //212,128. This POKE is advisable in any
* case if you are using Turbo, Supercharge, Qliberator, BASIC
* Reporter, SuperBasic-C-port or any other program that reads
* tokens from the SuperBasic program file.      SNG 14/1/93
*
* N.B: IT WAS ASSEMBLED WITH GST MACRO ASSEMBLER, NOT DEVPAC
*
* Replace one variable name with another
 pagewid 80

BP.INIT  equ $110
BV_PFBAS equ $10
BV_PFP   equ $14
ERR.BP   equ -15

 section main

start
 lea.l define,a1
 move.w BP.INIT,a2
 jsr (a2)
done
 moveq #0,d0
bad_par
 rts

define
 dc.w 1
 dc.w replace-*
 dc.b 7,'REPLACE'
 dc.w 0,0,0

jtab dc.b w,w,l,l,s,w,w,l,n,w,l,t,t,l,w,w
*         S K B B S O M S N S L S T L S B
*         P E I I Y P O Y A H G T X N E A
*         C Y P F M S N V M I I R T O P D
 ds.w 0

replace
 moveq #ERR.BP,d0
 moveq #-16,d6 also = FP byte
 add.l d6,a5 2*8 = two args reqd.
 cmp.l a3,a5
 bne.s bad_par
 move.w 2(a3,a6.l),d1 get name table pointer
 bmi.s bad_par not in name table
 move.w 10(a3,a6.l),d2 get name table pointer
 bmi.s bad_par not in name table

 moveq #10,d5 line feed symbol
 move.l BV_PFBAS(a6),a0 start of program

* Regs:
* d0.w is $FFxx all through this ...
* d1.w symbol to be replaced ...
* d2.w ... with this one.
* d3.w temporary
* d5.b 10
* d6.b $F0 
* a0.l SuperBasic program

new
 cmp.l BV_PFP(a6),a0 at the end of the program?
 bcc.s done yes - we're all done
lng
 addq.l #2,a0 skip length/lno/name
wrd
 addq.l #2,a0 move past next token entry
pick
 move.b -2(a6,a0.l),d0 get what we've moved over
 cmp.b d6,d0 is it FP, i.e. >= $F0?
 bcc.s fp yes - go skip it
 move.b jtab+$80(pc,d0.w),d0
 jmp jbase(pc,d0.w)

sym
 cmp.b -1(a6,a0.l),d5 is it an end of line?
 bne.s wrd no - done
 bra.s new yes - go see if it's the end

nam
 cmp.w 0(a6,a0.l),d1 to be replaced?
 bne.s lng no - step on
 move.w d2,0(a6,a0.l) yes - replace it ...
 bra.s lng ... then step on

txt
 move.w 0(a6,a0.l),d3 length
 add.w d3,a0 skip characters
jbase equ txt+2 ensure d0=-2 here
 or.w d0,d3 even:-2, odd:-1
 add.w d3,a0 rounded, six to go ...

fp
 addq.l #6,a0 step past 6 FP bytes 
 bra.s pick

w equ wrd-jbase
s equ sym-jbase
n equ nam-jbase
t equ txt-jbase
l equ lng-jbase

 end

