* QL WORLD DIY TOOLKIT - MORE keyword 1.1 by Simon N Goodwin, May-June 1991
* Source updated September 1993 with extra I's for pedantic assemblers.
*
buf        equr       a4             Replace BUF with A4 if you lack EQUR
output_id  equr       d5             Channel ID of the text output window
prompt_id  equr       d7             Channel ID of the prompt window (#0)
*
* Names for variables in Buffer, addressed with NAME(BUF,A6.L)
*
width      equ        0              WIDTH of output window, in characters
depth      equ        width+2        DEPTH of output window, in characters
old_top    equ        depth+2        File point at top of previous page
column     equ        old_top+4      Loading COLUMN & LINE corrupts OLD_TOP
line       equ        column+2       with the width & height of #0
maxtext    equ        line+2         MIN( BUFF_SIZE-TEXTBUF, DEPTH*WIDTH )
textleft   equ        maxtext+2      Number of bytes unscanned in buffer
textptr    equ        textleft+2     A6 offset to first unscanned byte
digits     equ        textptr+4      Buffer for 10 numeric digits (I hope)
top_left   equ        digits+10      File point at top left of next page
filename   equ        top_left+4     Space shared by file name, header etc.
length     equ        filename       LONG File length & start of file header
filetype   equ        length+5       Offset to File type byte in file header
dataspace  equ        length+6       Offset to LONG data space in header
headname   equ        length+14      Offset to name in file header
textbuf    equ        length+4       From here on is file text buffer space
*
start      lea.l      define,a1      Point at the details
           move.w     $110.w,a2      Use the BP.INIT vector
           jmp        (a2)
*
* MORE [ # CHANNEL% , ] FILE_NAME
*
more       moveq      #1,d1          Assume channel #1
           lea.l      8(a3),a4
           cmpa.l     a4,a5          Just one parameter?
           bmi        bad_param      Reject unless there is one!
           beq.s      channel
           exg        a4,a5          Isolate the first parameter
           move.w     $112.w,a2      CA.GTINT - get an integer
           jsr        (a2)
           bne        bad_exit
           move.l     a5,a3          Start of next parameter details
           move.l     a4,a5          End of supplied parameter info
           move.w     0(a1,a6.l),d1  Grab the channel number
           beq.s      bad_param      Alas, #0 is already needed
*
channel    move.l     48(a6),d2      Find the channel table
           move.l     0(a6,d2.l),d7  D7 is ID of channel #0
           mulu       #40,d1         Find offset in table
           add.l      d2,d1          Add base to offset
           cmp.l      52(a6),d1      Check not beyond end
           bge.s      what_chan
           move.l     0(a6,d1.l),a0  ID for output window
*
windows    move.l     (a6),buf       Find SuperBasic's fixed BUFFER offset
           ifeq       width
           move.l     buf,a1         Optimise code if WIDTH=0 (expected)
           endc
           ifne       width
           lea.l      width(buf),a1  Generate this if WIDTH is changed!
           endc
           moveq      #-1,d3         Wait forever if necessary
           bsr        windowspec     Read DEPTH & WIDTH of main window
           bne.s      bad_exit       Windows only! Reject imposters
           move.l     a0,output_id   Store ID for use later
           move.l     prompt_id,a0   Get busy in screen window #0
           moveq      #14,d0         SD.CURE; turn on the cursor in #0
           bsr        call_Qdos
           bne.s      bad_exit       Ahem, something is terribly wrong!
           lea.l      column-4(buf),a1  Four words; MORE uses 3rd & 4th
           bsr        windowspec     Read COLUMN & LINE for prompt window
*
* Get the file name parameter as a string or a name
*
get_name   tst.b      0(a3,a6.l)     Is the value set?
           bne.s      value_set      If so, use GTSTR to read it
           movea.l    24(a6),a0      A0 -> SuperBasic Name Table
           move.w     2(a3,a6.l),d0  D0 is index of parameter name
           lsl.w      #3,d0          Scale for eight byte entries
           adda.w     d0,a0          Implicitly extends D0 to match A0
           move.w     2(a0,a6.l),d0  D0 is offset of text in Name List 
           ext.l      d0             Data regs. need explicit extension
           add.l      32(a6),d0      Add Name List base offset
           move.l     d0,a2          Save total offset for later
           lea.l      filename(buf),a3
           move.l     a3,a0          Set name offset for OPEN later
           moveq      #0,d1          Clear high bytes of D1
           move.b     0(a6,d0.l),d1  D1 is length of name (1..255)
           clr.b      0(a3,a6.l)     Clear high byte of buffer word length
copy_name  move.b     0(a6,d0.l),1(a3,a6.l)
           addq.l     #1,a3          Advance through buffer
           addq.l     #1,d0          Advance through Name List
           dbra       d1,copy_name   Copy D1+1 bytes including length
           bra.s      name_ready
*
what_chan  moveq      #-6,d0         CHANNEL NOT OPEN error
bad_exit   rts
bad_param  moveq      #-15,d0        BAD PARAMETER error
           rts
*
* OPEN subroutine, tries to OPEN_IN the name at A0
*
try_open   moveq      #1,d0          Trap key for IO.OPEN
           moveq      #-1,d1         This task will own the channel
           moveq      #1,d3          Try to OPEN_IN
           trap       #4             Remember A6
           trap       #2
           tst.l      d0             Set Z flag if it worked
           rts
*
value_set  move.w     $116.w,a2      CA.GTSTR - get a string
           jsr        (a2)
           bne.s      bad_exit
           subq.w     #1,d3          Only one more parameter, please
           bne.s      bad_param
           lea.l      1(a1),a2       Save offset of length byte
           move.l     a1,a0          Find the string start
name_ready cmpi.w     #128-33-filename-2,0(a0,a6.l)  Allow default & data
           bpl.s      bad_param      Name too long, reject it
           bsr.s      try_open
           beq.s      opened         Hurrah, it worked! Avoid next effort
*
* Search out the DATAD$ default device prefix among the system variables
*
           move.l     d0,d3          Save the error code for later
           moveq      #0,d0          MT.INF trap key
           trap       #1             Find the System Variables
           move.l     176(a0),d0     D0=0 or points to the DATAD string
           beq.s      fail_d3        No default so return report code in D3 
           move.l     d0,a0
           move.w     (a0)+,d0       Pick up the string length
           bne.s      default_ok     If default is null, it won't help
fail_d3    move.l     d3,d0          Return error code from OPEN
           rts
*
* Copy default to the buffer, append the parameter, and re-try OPEN
*
default_ok lea.l      filename(buf),a3
           move.w     d0,d1          Save length for total
           subq.w     #1,d0
deft_copy  move.b     (a0)+,2(a3,a6.l)
           addq.l     #1,a3
           dbra       d0,deft_copy
           move.b     0(a2,a6.l),d0  Recall the length byte
           ext.w      d0
           add.w      d0,d1          Total length of the composite string
           subq.w     #1,d0
slow_copy  move.b     1(a2,a6.l),2(a3,a6.l)
           addq.l     #1,a3
           addq.l     #1,a2
           dbra       d0,slow_copy
           move.w     d1,filename(buf,a6.l)
           lea.l      filename(buf),a0 
           bsr.s      try_open       Try to open file; name is at (A0,A6)
           bne.s      bad_exit       Had enough? Give up and complain!
*
* File is open, Channel ID is in A0 - read header & write prompts to #0
*
opened     moveq      #64,d2         Buffer size
           lea.l      length(buf),a1 Read the file header
           moveq      #-1,d3         Infinite timeout
           moveq      #71,d0         FS.HEADR
           bsr        do_trap4       Read file header
           move.w     d1,d6          Save header length for later tests
           exg        prompt_id,a0   Swap from file to prompt channel ID
           bsr        tidy_wind      Clear space for file position
           cmpi.w     #64,d6         Was it a serial header?
           beq.s      full_head      Show file header details
           st         length(buf,a6.l)   Mark the length as 'enormous'
           bra.s      find_room      Skip the other messages
full_head  lea.l      spacer,a1
           bsr        print_abs      Separate current position from size
           move.l     length(buf,a6.l),d1
*
           bsr        print_long     Show total file size in bytes
           cmpi.b     #1,filetype(buf,a6.l)  Check A1 is still OK
           bne.s      not_task
           lea.l      lbracket,a1    Bracket data space
           bsr        print_abs
           move.l     dataspace(buf,a6.l),d1
           bsr        print_long     Show file data space in bytes
           lea.l      rbracket,a1    ...in brackets
           bsr        print_abs
not_task   lea.l      spacer2,a1     Yet more gratuitous ornamentation
           bsr        print_abs
           move.w     headname(buf,a6.l),d2 Pick up the file name length
           lea.l      headname+2(buf),a1  Point at the text
           trap       #4             Text address is A6 relative
           bsr        print_str      Print file name from header
find_room  move.l     8(a6),d0       Find end of buffer area
           sub.l      buf,d0         Subtract start to get size
           moveq      #textbuf,d1    Avoid slow LONG operand fetch
           sub.l      d1,d0          Leave room for buffer variables
           move.w     width(buf,a6.l),d1
           mulu       depth(buf,a6.l),d1
           cmp.l      d1,d0          Is the window bigger than the buffer?
           bls.s      screenfuls     Expects <= 32K characters/screen!
           move.l     d1,d0          Use all the buffer space we have
screenfuls move.w     d0,maxtext(buf,a6.l)
           clr.l      top_left(buf,a6.l)
none_left  clr.w      textleft(buf,a6.l)    Invalidate buffered text
           tas        old_top(buf,a6.l)     Invalidate 'last page'
           exg        a0,prompt_id   That's enough prompting for now
*
* Redraw screen forwards from the file to the main window
*
redraw     exg        output_id,a0   Select the main output channel
           moveq      #32,d0         SD.CLEAR - clear output window
           trap       #3
           exg        a0,output_id   Re-select the input file ID
           move.w     depth(buf,a6.l),d4
next_line  move.w     width(buf,a6.l),d6
*
* See what's already in the buffer (D1 bytes at TEXTPTR)
*
           move.w     textleft(buf,a6.l),d1
           beq.s      get_some
got_more   move.l     textptr(buf,a6.l),a1
           moveq      #10,d0         Pattern; looking for line end markers
scan_line  subq.w     #1,d1
           bmi.s      run_out        Get some more text
           cmp.b      0(a1,a6.l),d0  Check one character
           addq.l     #1,a1          Advance to next character
           beq.s      got_line       Line end found
           subq.w     #1,d6          Reduce remaining width
           bhi.s      scan_line
*
* The line is 'full', but we may be able to squeeze in a line end yet
*
line_full  tst.w      d1             Is the next byte in the buffer?
           beq.s      got_line       Trust to luck (and fail safe!)
           cmp.b      0(a1,a6.l),d0  Is it a Line end?
           bne.s      got_line       If not, leave it for later
           addq.l     #1,a1          We can accommodate that too
           subq.w     #1,d1
got_line   move.w     width(buf,a6.l),d6  Recall line width for later
           subq.w     #1,d4          Count one less display line
           bhi.s      scan_line      Continue if there's anything left
           move.l     a1,d2          Work out number of bytes scanned
           sub.l      textptr(buf,a6.l),d2 
           sub.w      d2,textleft(buf,a6.l)
           bsr        send_bytes      Display scanned buffer bytes
           move.l     a1,textptr(buf,a6.l)
           bra.s      find_ptr
*
run_out    move.w     textleft(buf,a6.l),d2    Display all we have
           bsr        send_bytes      Write buffer contents to display
get_some   move.w     maxtext(buf,a6.l),d2
           lea.l      textbuf(buf),a1  Reload the text buffer
           move.l     a1,textptr(buf,a6.l)
           moveq      #3,d0          IO.FSTRG - read D2 bytes to A1 
           bsr        do_trap4
           beq.s      fetched        No error, OK!
           cmpi.b     #-10,d0        End of file?
           bne.s      file_error     Anything else should be reported!
fetched    move.w     d1,textleft(buf,a6.l)
           beq.s      find_ptr       Nothing left to read?
           bra.s      got_more       Carry on with what's left

file_error move.l     d0,d2          Note the error code
           bsr        closer         Try to close the file (preserving D2)
           move.l     d2,d0          Return the file error to SuperBASIC
           rts
*
* Find file pointer and adapt to suit TEXTLEFT
*
find_ptr   moveq      #0,d1          No move
           moveq      #67,d0         FS.POSRE 
           trap       #3             Set D1.L to file pointer
           move.w     textleft(buf,a6.l),d2
           ext.l      d2
           sub.l      d2,d1          Don't count bytes not yet shown
*
* Seek start of line in report window and show file pointer value
*
update     move.l     d1,d4          Save file pointer for display later
           exg        prompt_id,a0   Retrieve prompt ID, save file ID
           bsr        line_start     SD.POS works like AT line,column
           move.l     d4,d1
           bsr        print_long     Print file pointer value
*
* Wait for ESC, Arrows, ENTER or ERR.NC and react accordingly 
*
keypoll    moveq      #1,d0          IO.FBYTE - get 1 key!
           trap       #3
           tst.l      d0             BREAK? EOF?? #0 gone?!
           bmi.s      stop_now       Errors here signal the end
           cmpi.b     #27,d1         ESC?
           bne.s      dont_stop      Escape also stops the action
*
* Close input file and move #0 to a new line, ready for the next command
*
stop_now   exg.l      a0,prompt_id   Save prompt ID, select file ID
closer     moveq      #2,d0          IO.CLOSE
           trap       #2             That had better work!
           move.l     prompt_id,a0   Now tidy up the prompt line
           moveq      #15,d0         SD.CURS - suppress cursor
           trap       #3
           moveq      #10,d1         Send Newline to #0
           bra        print_byte     Exit via Qdos TRAP #3
*
dont_stop  exg        a0,prompt_id   Save prompt ID, restore file ID
           cmpi.b     #216,d1        Line Down (down arrow) ?
           bne.s      try_paging
           cmp.l      length(buf,a6.l),d4
           beq.s      seek_start
           moveq      #1,d4          Depth is one line
           bra        next_line      Scroll one extra line
           
try_paging cmpi.b     #217,d1        Page Down, ALT down arrow?
           bne.s      not_down
           move.l     top_left(buf,a6.l),old_top(buf,a6.l)
           move.l     d4,top_left(buf,a6.l)  
           cmp.l      length(buf,a6.l),d4
           bne        redraw         Page forward
seek_start moveq      #0,d1          Seek start of file
seek_d1    move.l     d1,top_left(buf,a6.l)  
           moveq      #66,d0         FS.POSAB
           trap       #3
blank_out  exg        prompt_id,a0   Retrieve prompt ID, save file ID
blank_outp bsr        tidy_wind      Blank the previous pointer value
           bra        none_left
*
* Page back; check 'top'; if at start of file, wind to end
* Move file pointer back to previous page or by set distance
*
not_down   cmpi.b     #209,d1        Page Up (ALT up arrow) ?
           bne.s      not_up
           tst.l      top_left(buf,a6.l)
           bne.s      wind_back      Move back unless previously at top
           move.l     length(buf,a6.l),d1
           sub.l      #512,d1        D1 is 0.5K before the end of the file
           bpl.s      seek_d1        Wind the file pointer there
try_again  exg        prompt_id,a0   Restore prompt ID
           bra.s      keypoll        Eeek! Await further instructions
*
wind_back  move.l     old_top(buf,a6.l),d1
           bpl.s      seek_d1        Use old top if it is valid
           subi.l     #2048,d4       Try to move back 2K bytes
           bmi.s      seek_start     Too far? Go to start instead
           move.l     d4,d1
           bra.s      seek_d1        Move backwards
*
not_up     cmpi.b     #10,d1         ENTER key code?
           bne.s      try_again
*
* ENTER = Get new position
*
           exg        prompt_id,a0   Retrieve prompt ID, save file ID
           bsr.s      tidy_wind      Scrub the existing value
           bsr        line_start     Get ready to read a new value
           moveq      #10,d2         Buffer size
           lea.l      digits(buf),a1 Point at the buffer
           moveq      #2,d0          IO.FLINE
           bsr.s      do_trap4
           bne.s      bad_entry      Error, redraw!
got_entry  subq.w     #1,d1          Several bytes, please
           ble.s      bad_entry      Ignore a null entry
           lea.l      digits(buf),a1 Point at the buffer
           bsr        long_value     Evaluate digit string into D1.L
           beq.s      move_there     If no error, use the new D1
bad_entry  move.l     top_left(buf,a6.l),d1   Redraw last full page
move_there moveq      #-1,d3         Restore corrupted timeout
           move.l     d1,d4
           moveq      #20,d0         SD.NCOL, cancel pending new line
           trap       #3
           moveq      #14,d0         Re-enable cursor
           trap       #3
           exg        a0,prompt_id   Retrieve file ID
           move.l     d4,d1          and required position
           bra.s      seek_d1        Move there
*
* D1.L to ASCII TEXT OUTPUT SUBROUTINE; A0 is Channel; Uses A1, A3, D0-D2 
* 
print_long lea.l      digits(buf),a3
           tst.l      d1             Zero is a simple case
           bne.s      not_zero
           moveq      #'0',d1        Digit zero
print_byte moveq      #5,d0          IO.SBYTE
           bra.s      call_Qdos
not_zero   moveq      #9,d2          DBRA counter for up to 10 digits
op_digits  moveq      #0,d0          Now buffer D1 as a 32
           swap       d1             bit unsigned integer,
           beq.s      enough
           move.w     d1,d0          last digit 'first',
           divu       #10,d0         from 9(A3,A6) backwards
           swap       d0
           move.w     d0,d1
           swap       d1             Divide the other 16 bits
           divu       #10,d1         Long integer division
           move.w     d1,d0          needs two steps pre-68020!
           swap       d1
           exg        d1,d0
           addi.b     #'0',d0        Convert digit number to ASCII
           move.b     d0,9(a3,a6.l)  Store at end of digit buffer
           subq.l     #1,a3          Move backwards through buffer
           dbra       d2,op_digits   Count 9 to -1 for digits 10 to 1
*
enough     lea.l      digits+1(buf,d2.w),a1  A1 -> first significant digit
           neg.w      d2
           addi.w     #9,d2          Number length is 9 - D2 from DBRA
print_rel  trap       #4             Buffer is relative to A6
           bra.s      print_str
*
tidy_wind  bsr.s      line_start
           lea.l      blanks,a1
print_abs  move.w     (a1)+,d2       Pick up string length
print_str  moveq      #7,d0          IO.SSTRG
           trap       #3             Display the text; no errors expected
           rts
*
windowspec moveq      #11,d0         SD.CHENQ trap key, window enquiry
do_trap4   trap       #4             Addresses are A6 offsets
call_QDOS  trap       #3             General-purpose ROM caller
           tst.l      d0             Set Z to signal ERR.OK
           rts
*
line_start move.w     line(buf,a6.l),d2
           move.w     column(buf,a6.l),d1
           moveq      #16,d0         SD.POS
           bra.s      call_Qdos      Move to character position
*
send_bytes exg        output_id,a0   Select screen output channel
           move.l     textptr(buf,a6.l),a1
           bsr.s      print_rel
           exg        a0,output_id   Restore file ID
           rts
*
* ASCII TEXT to LONG WORD COERCION SUBROUTINE
* Text @ (A1,A6), D1.W = length, 1-9; uses D2 & D3; A1 points beyond last
* character on return, D1 is a LONG result and D0 is error code, 0 or -17.
*
long_value move.w     d1,d2          D2 is length un-scanned
           moveq      #0,d1          The result accumulates here
           moveq      #0,d3          LONG store for each digit
next_digit move.b     0(a1,a6.l),d3
           addq.l     #1,a1
           cmpi.b     #'9',d3
           bhi.s      bad_value      Not more than '9'
           subi.b     #'0',d3        Convert ASCII to value
           bcs.s      bad_value
           add.l      d1,d1          D1:=D1 * 2
           move.l     d1,d0          Save D1 * 2
           asl.l      #2,d1          D1:= (D1 * 2) * 4
           add.l      d0,d1          D1:= initial D1 * 10
           add.l      d3,d1          Add digit to running total
           subq.w     #1,d2          One less character to read
           bne.s      next_digit
got_along  moveq      #0,d0          No error, result in D1 
           rts
*
bad_value  moveq      #-17,d0        Error in expression
           rts
*
blanks     dc.w       10
           dc.b       '          '   One space for each digit
spacer     dc.w       4
           dc.b       ' of '         Spaces either side
lbracket   dc.w       2
           dc.b       ' {'           One leading space
rbracket   dc.w       1
           dc.b       '}'            No spaces
spacer2    dc.w       4
           dc.b       ' in '         One space each side
*
define     dc.w       1              Just one Procedure
           dc.w       more-*
           dc.b       4,'MORE'
           dc.w       0,0,0          End of Proc list, no FNs
           end
